/** Copyright (c) 2018 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
export default class ResponseError extends Error {
    code: string | undefined | null;
    meta: any;
    cause: unknown | undefined | null;
    severity: typeof ResponseError.Severity[keyof typeof ResponseError.Severity] | undefined | null;
    static Severity: Readonly<{
        HIGH: "HIGH";
        MEDIUM: "MEDIUM";
    }>;
    constructor(message: string, options?: {
        code?: string;
        meta?: any;
        cause?: unknown;
        severity?: typeof ResponseError.Severity[keyof typeof ResponseError.Severity];
    } | null);
}
//# sourceMappingURL=response-error.d.ts.map